wxWidgets: wxConfigBase Class Reference

| Version: 3.0.2

- Main Page
- Related Pages
- Categories
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | List of all members
wxConfigBase Class Referenceabstract
Application and System configuration

`#include <wx/config.h>`

Inheritance diagram for wxConfigBase:
[legend]

## Detailed Description

wxConfigBase defines the basic interface of all config classes.

It cannot be used by itself (it is an abstract base class) and you will always use one of its derivations: wxFileConfig, wxRegConfig or any other.

However, usually you don't even need to know the precise nature of the class you're working with but you would just use the wxConfigBase methods. This allows you to write the same code regardless of whether you're working with the registry under Windows or text-based config files under Unix. To make writing the portable code even easier, wxWidgets provides a typedef wxConfig which is mapped onto the native wxConfigBase implementation on the given platform: i.e. wxRegConfig under Windows and wxFileConfig otherwise.

See wxConfig Overview for a description of all features of this class.

It is highly recommended to use static functions Get() and/or Set(), so please have a look at them.

Related Include Files:

- `<wx/config.h>` - Let wxWidgets choose a wxConfig class for your platform.
- `<wx/confbase.h>` - Base config class.
- `<wx/fileconf.h>` - wxFileConfig class.
- `<wx/msw/regconf.h>` - wxRegConfig class, see also wxRegKey.

# Example

Here is how you would typically use this class:

// using wxConfig instead of writing wxFileConfig or wxRegConfig enhances
// portability of the code
wxConfig *config = new wxConfig("MyAppName");
wxString str;
if ( config->Read("LastPrompt", &str) ) {
// last prompt was found in the config file/registry and its value is
// now in str
// ...
}
else {
// no last prompt...
}
// another example: using default values and the full path instead of just
// key name: if the key is not found , the value 17 is returned
long value = config->ReadLong("/LastRun/CalculatedValues/MaxValue", 17);
// at the end of the program we would save everything back
config->Write("LastPrompt", str);
config->Write("/LastRun/CalculatedValues/MaxValue", value);
// the changes will be written back automatically
delete config;

This basic example, of course, doesn't show all wxConfig features, such as enumerating, testing for existence and deleting the entries and groups of entries in the config file, its abilities to automatically store the default values or expand the environment variables on the fly. However, the main idea is that using this class is easy and that it should normally do what you expect it to.

Note
  In the documentation of this class, the words "config file" also mean "registry hive" for wxRegConfig and, generally speaking, might mean any physical storage where a wxConfigBase-derived class stores its data.

# Static Functions

The static functions provided deal with the "default" config object. Although its usage is not at all mandatory it may be convenient to use a global config object instead of creating and deleting the local config objects each time you need one (especially because creating a wxFileConfig object might be a time consuming operation). In this case, you may create this global config object in the very start of the program and Set() it as the default. Then, from anywhere in your program, you may access it using the Get() function. This global wxConfig object will be deleted by wxWidgets automatically if it exists. Note that this implies that if you do delete this object yourself (usually in wxApp::OnExit()) you must use Set(NULL) to prevent wxWidgets from deleting it the second time.

As it happens, you may even further simplify the procedure described above: you may forget about calling Set(). When Get() is called and there is no current object, it will create one using Create() function. To disable this behaviour DontCreateOnDemand() is provided.

Note
  You should use either Set() or Get() because wxWidgets library itself would take advantage of it and could save various information in it. For example wxFontMapper or Unix version of wxFileDialog have the ability to use wxConfig class.

# Path Management

As explained in the config overview, the config classes support a file system-like hierarchy of keys (files) and groups (directories). As in the file system case, to specify a key in the config class you must use a path to it. Config classes also support the notion of the current group, which makes it possible to use the relative paths. To clarify all this, here is an example (it is only for the sake of demonstration, it doesn't do anything sensible!):

wxConfig *config = new wxConfig("FooBarApp");
// right now the current path is '/'
conf->Write("RootEntry", 1);
// go to some other place: if the group(s) don't exist, they will be created
conf->SetPath("/Group/Subgroup");
// create an entry in subgroup
conf->Write("SubgroupEntry", 3);
// '..' is understood
conf->Write("../GroupEntry", 2);
conf->SetPath("..");
wxASSERT( conf->ReadLong("Subgroup/SubgroupEntry", 0) == 3 );
// use absolute path: it is allowed, too
wxASSERT( conf->ReadLong("/RootEntry", 0) == 1 );

It is highly recommended that you restore the path to its old value on function exit:

void foo(wxConfigBase *config)
{
wxString strOldPath = config->GetPath();
config->SetPath("/Foo/Data");
// ...
config->SetPath(strOldPath);
}

Otherwise the assert in the following example will surely fail (we suppose here that the foo() function is the same as above except that it doesn’t save and restore the path):

void bar(wxConfigBase *config)
{
config->Write("Test", 17);
foo(config);
// we're reading "/Foo/Data/Test" here! -1 will probably be returned...
wxASSERT( config->ReadLong("Test", -1) == 17 );
}

Finally, the path separator in wxConfigBase and derived classes is always "/", regardless of the platform (i.e. it is not "\\" under Windows).

# Enumeration

The enumeration functions allow you to enumerate all entries and groups in the config file. All functions here return false when there are no more items.

You must pass the same index to GetNext() and GetFirst() (don't modify it). Please note that it is not the index of the current item (you will have some great surprises with wxRegConfig if you assume this) and you shouldn't even look at it: it is just a "cookie" which stores the state of the enumeration. It can't be stored inside the class because it would prevent you from running several enumerations simultaneously, that's why you must pass it explicitly.

Having said all this, enumerating the config entries/groups is very simple:

wxConfigBase *config = ...;
wxArrayString aNames;
// enumeration variables
wxString str;
long dummy;
// first enum all entries
bool bCont = config->GetFirstEntry(str, dummy);
while ( bCont ) {
aNames.Add(str);
bCont = GetConfig()->GetNextEntry(str, dummy);
}
// ... we have all entry names in aNames...
// now all groups...
bCont = GetConfig()->GetFirstGroup(str, dummy);
while ( bCont ) {
aNames.Add(str);
bCont = GetConfig()->GetNextGroup(str, dummy);
}
// ... we have all group (and entry) names in aNames...

There are also functions to get the number of entries/subgroups without actually enumerating them, but you will probably never need them.

# Key Access

The key access functions are the core of wxConfigBase class: they allow you to read and write config file data. All Read() functions take a default value which will be returned if the specified key is not found in the config file.

Currently, supported types of data are: wxString, `long`, `double`, `bool`, wxColour and any other types for which the functions wxToString() and wxFromString() are defined.

Try not to read long values into string variables and vice versa: although it just might work with wxFileConfig, you will get a system error with wxRegConfig because in the Windows registry the different types of entries are indeed used.

Final remark: the szKey parameter for all these functions can contain an arbitrary path (either relative or absolute), not just the key name.

##

Library: wxBase
Category: Application and System configuration

See Also
  wxConfigPathChanger

## Public Types
enum | EntryType { Type_Unknown, Type_String, Type_Boolean, Type_Integer, Type_Float }

## Public Member Functions
| wxConfigBase (const wxString &appName=wxEmptyString, const wxString &vendorName=wxEmptyString, const wxString &localFilename=wxEmptyString, const wxString &globalFilename=wxEmptyString, long style=0, const wxMBConv &conv=wxConvAuto())
| This is the default and only constructor of the wxConfigBase class, and derived classes.
virtual | ~wxConfigBase ()
| Empty but ensures that dtor of all derived classes is virtual.
Path Management
See Path Management
virtual const wxString & | GetPath () const =0
| Retrieve the current path (always as absolute path).
virtual void | SetPath (const wxString &strPath)=0
| Set current path: if the first character is '/', it is the absolute path, otherwise it is a relative path.
Enumeration
See Enumeration
virtual bool | GetFirstEntry (wxString &str, long &index) const =0
| Gets the first entry.
virtual bool | GetFirstGroup (wxString &str, long &index) const =0
| Gets the first group.
virtual bool | GetNextEntry (wxString &str, long &index) const =0
| Gets the next entry.
virtual bool | GetNextGroup (wxString &str, long &index) const =0
| Gets the next group.
virtual size_t | GetNumberOfEntries (bool bRecursive=false) const =0
| Get number of entries in the current group.
virtual size_t | GetNumberOfGroups (bool bRecursive=false) const =0
| Get number of entries/subgroups in the current group, with or without its subgroups.
Tests of Existence
bool | Exists (const wxString &strName) const
virtual wxConfigBase::EntryType | GetEntryType (const wxString &name) const
| Returns the type of the given entry or Unknown if the entry doesn't exist.
virtual bool | HasEntry (const wxString &strName) const =0
virtual bool | HasGroup (const wxString &strName) const =0
Miscellaneous Functions
wxString | GetAppName () const
| Returns the application name.
wxString | GetVendorName () const
| Returns the vendor name.
Key Access
See Key Access
virtual bool | Flush (bool bCurrentOnly=false)=0
| Permanently writes all changes (otherwise, they're only written from object's destructor).
bool | Read (const wxString &key, wxString *str) const
| Read a string from the key, returning true if the value was read.
bool | Read (const wxString &key, wxString *str, const wxString &defaultVal) const
| Read a string from the key.
const wxString | Read (const wxString &key, const wxString &defaultVal) const
| Another version of Read(), returning the string value directly.
bool | Read (const wxString &key, long *l) const
| Reads a long value, returning true if the value was found.
bool | Read (const wxString &key, long *l, long defaultVal) const
| Reads a long value, returning true if the value was found.
bool | Read (const wxString &key, double *d) const
| Reads a double value, returning true if the value was found.
bool | Read (const wxString &key, double *d, double defaultVal) const
| Reads a double value, returning true if the value was found.
bool | Read (const wxString &key, float *f) const
| Reads a float value, returning true if the value was found.
bool | Read (const wxString &key, float *f, float defaultVal) const
| Reads a float value, returning true if the value was found.
bool | Read (const wxString &key, bool *b) const
| Reads a boolean value, returning true if the value was found.
bool | Read (const wxString &key, bool *d, bool defaultVal) const
| Reads a boolean value, returning true if the value was found.
bool | Read (const wxString &key, wxMemoryBuffer *buf) const
| Reads a binary block, returning true if the value was found.
bool | Read (const wxString &key, T *value) const
| Reads a value of type T, for which function wxFromString() is defined, returning true if the value was found.
bool | Read (const wxString &key, T *value, const T &defaultVal) const
| Reads a value of type T, for which function wxFromString() is defined, returning true if the value was found.
bool | ReadBool (const wxString &key, bool defaultVal) const
| Reads a bool value from the key and returns it.
double | ReadDouble (const wxString &key, double defaultVal) const
| Reads a double value from the key and returns it.
long | ReadLong (const wxString &key, long defaultVal) const
| Reads a long value from the key and returns it.
T | ReadObject (const wxString &key, T const &defaultVal) const
| Reads a value of type T (for which the function wxFromString() must be defined) from the key and returns it.
bool | Write (const wxString &key, const wxString &value)
| Writes the wxString value to the config file and returns true on success.
bool | Write (const wxString &key, long value)
| Writes the long value to the config file and returns true on success.
bool | Write (const wxString &key, double value)
| Writes the double value to the config file and returns true on success.
bool | Write (const wxString &key, bool value)
| Writes the bool value to the config file and returns true on success.
bool | Write (const wxString &key, const wxMemoryBuffer &buf)
| Writes the wxMemoryBuffer value to the config file and returns true on success.
bool | Write (const wxString &key, T const &buf)
| Writes the specified value to the config file and returns true on success.
Rename Entries/Groups
These functions allow renaming entries or subgroups of the current group. They will return false on error, typically because either the entry/group with the original name doesn't exist, because the entry/group with the new name already exists or because the function is not supported in this wxConfig implementation.
virtual bool | RenameEntry (const wxString &oldName, const wxString &newName)=0
| Renames an entry in the current group.
virtual bool | RenameGroup (const wxString &oldName, const wxString &newName)=0
| Renames a subgroup of the current group.
Delete Entries/Groups
These functions delete entries and/or groups of entries from the config file. DeleteAll() is especially useful if you want to erase all traces of your program presence: for example, when you uninstall it.
virtual bool | DeleteAll ()=0
| Delete the whole underlying object (disk file, registry key, ...).
virtual bool | DeleteEntry (const wxString &key, bool bDeleteGroupIfEmpty=true)=0
| Deletes the specified entry and the group it belongs to if it was the last key in it and the second parameter is true.
virtual bool | DeleteGroup (const wxString &key)=0
| Delete the group (with all subgroups).
Options
Some aspects of wxConfigBase behaviour can be changed during run-time. The first of them is the expansion of environment variables in the string values read from the config file: for example, if you have the following in your config file: # config file for my program UserData = $HOME/data # the following syntax is valid only under Windows UserData = %windir%\\data.dat The call to Read("UserData") will return something like `"/home/zeitlin/data"` on linux for example. Although this feature is very useful, it may be annoying if you read a value which contains '$' or '' symbols (% is used for environment variables expansion under Windows) which are not used for environment variable expansion. In this situation you may call SetExpandEnvVars(false) just before reading this value and SetExpandEnvVars(true) just after. Another solution would be to prefix the offending symbols with a backslash.
bool | IsExpandingEnvVars () const
| Returns true if we are expanding environment variables in key values.
bool | IsRecordingDefaults () const
| Returns true if we are writing defaults back to the config file.
void | SetExpandEnvVars (bool bDoIt=true)
| Determine whether we wish to expand environment variables in key values.
void | SetRecordDefaults (bool bDoIt=true)
| Sets whether defaults are recorded to the config file whenever an attempt to read the value which is not present in it is done.
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data.
| wxObject (const wxObject &other)
| Copy ctor.
virtual | ~wxObject ()
| Destructor.
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar).
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object.
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class.
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj.
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone.
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer.
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data.
void | UnShare ()
| This is the same of AllocExclusive() but this method is public.
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined.
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined.

## Static Public Member Functions
static wxConfigBase * | Create ()
| Create a new config object and sets it as the current one.
static void | DontCreateOnDemand ()
| Calling this function will prevent Get() from automatically creating a new config object if the current one is NULL.
static wxConfigBase * | Get (bool CreateOnDemand=true)
| Get the current config object.
static wxConfigBase * | Set (wxConfigBase *pConfig)
| Sets the config object as the current one, returns the pointer to the previous current object (both the parameter and returned value may be NULL).

## Additional Inherited Members
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object.
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it.
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data.
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data.

## Member Enumeration Documentation

enum wxConfigBase::EntryType

Enumerator:

  Type_Unknown |
  Type_String |
  Type_Boolean |
  Type_Integer |
  Type_Float |

## Constructor & Destructor Documentation

wxConfigBase::wxConfigBase | ( | const wxString & | appName = `wxEmptyString`,
|  | const wxString & | vendorName = `wxEmptyString`,
|  | const wxString & | localFilename = `wxEmptyString`,
|  | const wxString & | globalFilename = `wxEmptyString`,
|  | long | style = `0`,
|  | const wxMBConv & | conv = `wxConvAuto()`
| ) |  |

This is the default and only constructor of the wxConfigBase class, and derived classes.

Parameters

  appName | The application name. If this is empty, the class will normally use wxApp::GetAppName() to set it. The application name is used in the registry key on Windows, and can be used to deduce the local filename parameter if that is missing.
  vendorName | The vendor name. If this is empty, it is assumed that no vendor name is wanted, if this is optional for the current config class. The vendor name is appended to the application name for wxRegConfig.
  localFilename | Some config classes require a local filename. If this is not present, but required, the application name will be used instead.
  globalFilename | Some config classes require a global filename. If this is not present, but required, the application name will be used instead.
  style | Can be one of `wxCONFIG_USE_LOCAL_FILE` and `wxCONFIG_USE_GLOBAL_FILE`. The style interpretation depends on the config class and is ignored by some implementations. For wxFileConfig, these styles determine whether a local or global config file is created or used: if `wxCONFIG_USE_GLOBAL_FILE` is used, then settings are read from the global config file and if `wxCONFIG_USE_LOCAL_FILE` is used, settings are read from and written to local config file (if they are both set, global file is read first, then local file, overwriting global settings). If the flag is present but the parameter is empty, the parameter will be set to a default. If the parameter is present but the style flag not, the relevant flag will be added to the style. For wxRegConfig, the GLOBAL flag refers to the `HKLM` key while LOCAL one is for the usual `HKCU` one. For wxFileConfig you can also add `wxCONFIG_USE_RELATIVE_PATH` by logically or'ing it to either of the _FILE options to tell wxFileConfig to use relative instead of absolute paths. On non-VMS Unix systems, the default local configuration file is "~/.appname". However, this path may be also used as user data directory (see wxStandardPaths::GetUserDataDir()) if the application has several data files. In this case `wxCONFIG_USE_SUBDIR` flag, which changes the default local configuration file to "~/.appname/appname" should be used. Notice that this flag is ignored if localFilename is provided. `wxCONFIG_USE_SUBDIR` is new since wxWidgets version 2.8.2. For wxFileConfig, you can also add `wxCONFIG_USE_NO_ESCAPE_CHARACTERS` which will turn off character escaping for the values of entries stored in the config file: for example a foo key with some backslash characters will be stored as "foo=C:\mydir" instead of the usual storage of "foo=C:\\mydir". The `wxCONFIG_USE_NO_ESCAPE_CHARACTERS` style can be helpful if your config file must be read or written to by a non-wxWidgets program (which might not understand the escape characters). Note, however, that if `wxCONFIG_USE_NO_ESCAPE_CHARACTERS` style is used, it is now your application's responsibility to ensure that there is no newline or other illegal characters in a value, before writing that value to the file.
  conv | This parameter is only used by wxFileConfig when compiled in Unicode mode. It specifies the encoding in which the configuration file is written.

Remarks
  By default, environment variable expansion is on and recording defaults is off.

virtual wxConfigBase::~wxConfigBase | ( |  | ) |
| virtual

Empty but ensures that dtor of all derived classes is virtual.

## Member Function Documentation

static wxConfigBase* wxConfigBase::Create | ( |  | ) |
| static

Create a new config object and sets it as the current one.

This function will create the most appropriate implementation of wxConfig available for the current platform. By default this means that the system registry will be used for storing the configuration information under MSW and a file under the user home directory (see wxStandardPaths::GetUserConfigDir()) elsewhere.

If you prefer to use the configuration files everywhere, you can define `wxUSE_CONFIG_NATIVE` to 0 when compiling wxWidgets. Or you can simply always create wxFileConfig explicitly.

Finally, if you want to create a custom wxConfig subclass you may change this function behaviour by overriding wxAppTraits::CreateConfig() to create it. An example when this could be useful could be an application which could be installed either normally (in which case the default behaviour of using wxRegConfig is appropriate) or in a "portable" way in which case a wxFileConfig with a file in the program directory would be used and the choice would be done in CreateConfig() at run-time.

virtual bool wxConfigBase::DeleteAll | ( |  | ) |
| pure virtual

Delete the whole underlying object (disk file, registry key, ...).

Primarily for use by uninstallation routine.

Implemented in wxFileConfig.

virtual bool wxConfigBase::DeleteEntry | ( | const wxString & | key,
|  | bool | bDeleteGroupIfEmpty = `true`
| ) |  |
| pure virtual

Deletes the specified entry and the group it belongs to if it was the last key in it and the second parameter is true.

Implemented in wxFileConfig.

virtual bool wxConfigBase::DeleteGroup | ( | const wxString & | key | ) |
| pure virtual

Delete the group (with all subgroups).

If the current path is under the group being deleted it is changed to its deepest still existing component. E.g. if the current path is `"/A/B/C/D"` and the group `C` is deleted, the path becomes `"/A/B"`.

Implemented in wxFileConfig.

static void wxConfigBase::DontCreateOnDemand | ( |  | ) |
| static

Calling this function will prevent Get() from automatically creating a new config object if the current one is NULL.

It might be useful to call it near the program end to prevent "accidental" creation of a new config object.

bool wxConfigBase::Exists | ( | const wxString & | strName | ) | const

Returns
  true if either a group or an entry with a given name exists.

virtual bool wxConfigBase::Flush | ( | bool | bCurrentOnly = `false` | ) |
| pure virtual

Permanently writes all changes (otherwise, they're only written from object's destructor).

Implemented in wxFileConfig.

static wxConfigBase* wxConfigBase::Get | ( | bool | CreateOnDemand = `true` | ) |
| static

Get the current config object.

If there is no current object and CreateOnDemand is true, this creates one (using Create()) unless DontCreateOnDemand() was called previously.

wxString wxConfigBase::GetAppName | ( |  | ) | const

Returns the application name.

virtual wxConfigBase::EntryType wxConfigBase::GetEntryType | ( | const wxString & | name | ) | const
| virtual

Returns the type of the given entry or Unknown if the entry doesn't exist.

This function should be used to decide which version of Read() should be used because some of wxConfig implementations will complain about type mismatch otherwise: e.g., an attempt to read a string value from an integer key with wxRegConfig will fail.

virtual bool wxConfigBase::GetFirstEntry | ( | wxString & | str,
|  | long & | index
| ) |  | const
| pure virtual

Gets the first entry.

wxPerl Note: In wxPerl this method takes no parameters and returns a 3-element list (continue_flag, string, index_for_getnextentry).

Implemented in wxFileConfig.

virtual bool wxConfigBase::GetFirstGroup | ( | wxString & | str,
|  | long & | index
| ) |  | const
| pure virtual

Gets the first group.

wxPerl Note: In wxPerl this method takes no parameters and returns a 3-element list (continue_flag, string, index_for_getnextentry).

Implemented in wxFileConfig.

virtual bool wxConfigBase::GetNextEntry | ( | wxString & | str,
|  | long & | index
| ) |  | const
| pure virtual

Gets the next entry.

wxPerl Note: In wxPerl this method only takes the index parameter and returns a 3-element list (continue_flag, string, index_for_getnextentry).

Implemented in wxFileConfig.

virtual bool wxConfigBase::GetNextGroup | ( | wxString & | str,
|  | long & | index
| ) |  | const
| pure virtual

Gets the next group.

wxPerl Note: In wxPerl this method only takes the index parameter and returns a 3-element list (continue_flag, string, index_for_getnextentry).

Implemented in wxFileConfig.

virtual size_t wxConfigBase::GetNumberOfEntries | ( | bool | bRecursive = `false` | ) | const
| pure virtual

Get number of entries in the current group.

Implemented in wxFileConfig.

virtual size_t wxConfigBase::GetNumberOfGroups | ( | bool | bRecursive = `false` | ) | const
| pure virtual

Get number of entries/subgroups in the current group, with or without its subgroups.

Implemented in wxFileConfig.

virtual const wxString& wxConfigBase::GetPath | ( |  | ) | const
| pure virtual

Retrieve the current path (always as absolute path).

Implemented in wxFileConfig.

wxString wxConfigBase::GetVendorName | ( |  | ) | const

Returns the vendor name.

virtual bool wxConfigBase::HasEntry | ( | const wxString & | strName | ) | const
| pure virtual

Returns
  true if the entry by this name exists.

Implemented in wxFileConfig.

virtual bool wxConfigBase::HasGroup | ( | const wxString & | strName | ) | const
| pure virtual

Returns
  true if the group by this name exists.

Implemented in wxFileConfig.

bool wxConfigBase::IsExpandingEnvVars | ( |  | ) | const

Returns true if we are expanding environment variables in key values.

bool wxConfigBase::IsRecordingDefaults | ( |  | ) | const

Returns true if we are writing defaults back to the config file.

bool wxConfigBase::Read | ( | const wxString & | key,
|  | wxString * | str
| ) |  | const

Read a string from the key, returning true if the value was read.

If the key was not found, str is not changed.

wxPerl Note: Not supported by wxPerl.

bool wxConfigBase::Read | ( | const wxString & | key,
|  | wxString * | str,
|  | const wxString & | defaultVal
| ) |  | const

Read a string from the key.

The default value is returned if the key was not found.

Returns
  true if value was really read, false if the default was used.

wxPerl Note: Not supported by wxPerl.

const wxString wxConfigBase::Read | ( | const wxString & | key,
|  | const wxString & | defaultVal
| ) |  | const

Another version of Read(), returning the string value directly.

wxPerl Note: In wxPerl, this can be called as:

- Read(key): returns the empty string if no key is found
- Read(key, default): returns the default value if no key is found

bool wxConfigBase::Read | ( | const wxString & | key,
|  | long * | l
| ) |  | const

Reads a long value, returning true if the value was found.

If the value was not found, l is not changed.

wxPerl Note: Not supported by wxPerl.

bool wxConfigBase::Read | ( | const wxString & | key,
|  | long * | l,
|  | long | defaultVal
| ) |  | const

Reads a long value, returning true if the value was found.

If the value was not found, defaultVal is used instead.

wxPerl Note: In wxPerl, this can be called as:

- ReadInt(key): returns the 0 if no key is found
- ReadInt(key, default): returns the default value if no key is found

bool wxConfigBase::Read | ( | const wxString & | key,
|  | double * | d
| ) |  | const

Reads a double value, returning true if the value was found.

If the value was not found, d is not changed.

wxPerl Note: Not supported by wxPerl.

bool wxConfigBase::Read | ( | const wxString & | key,
|  | double * | d,
|  | double | defaultVal
| ) |  | const

Reads a double value, returning true if the value was found.

If the value was not found, defaultVal is used instead.

wxPerl Note: In wxPerl, this can be called as:

- ReadFloat(key): returns the 0.0 if no key is found
- ReadFloat(key, default): returns the default value if no key is found

bool wxConfigBase::Read | ( | const wxString & | key,
|  | float * | f
| ) |  | const

Reads a float value, returning true if the value was found.

If the value was not found, f is not changed.

Notice that the value is read as a double but must be in a valid range for floats for the function to return true.

Since
  2.9.1

wxPerl Note: Not supported by wxPerl.

bool wxConfigBase::Read | ( | const wxString & | key,
|  | float * | f,
|  | float | defaultVal
| ) |  | const

Reads a float value, returning true if the value was found.

If the value was not found, defaultVal is used instead.

Notice that the value is read as a double but must be in a valid range for floats for the function to return true.

Since
  2.9.1

wxPerl Note: Not supported by wxPerl.

bool wxConfigBase::Read | ( | const wxString & | key,
|  | bool * | b
| ) |  | const

Reads a boolean value, returning true if the value was found.

If the value was not found, b is not changed.

Since
  2.9.1

wxPerl Note: Not supported by wxPerl.

bool wxConfigBase::Read | ( | const wxString & | key,
|  | bool * | d,
|  | bool | defaultVal
| ) |  | const

Reads a boolean value, returning true if the value was found.

If the value was not found, defaultVal is used instead.

wxPerl Note: In wxPerl, this can be called as:

- ReadBool(key): returns false if no key is found
- ReadBool(key, default): returns the default value if no key is found

bool wxConfigBase::Read | ( | const wxString & | key,
|  | wxMemoryBuffer * | buf
| ) |  | const

Reads a binary block, returning true if the value was found.

If the value was not found, buf is not changed.

bool wxConfigBase::Read | ( | const wxString & | key,
|  | T * | value
| ) |  | const

Reads a value of type T, for which function wxFromString() is defined, returning true if the value was found.

If the value was not found, value is not changed.

bool wxConfigBase::Read | ( | const wxString & | key,
|  | T * | value,
|  | const T & | defaultVal
| ) |  | const

Reads a value of type T, for which function wxFromString() is defined, returning true if the value was found.

If the value was not found, defaultVal is used instead.

bool wxConfigBase::ReadBool | ( | const wxString & | key,
|  | bool | defaultVal
| ) |  | const

Reads a bool value from the key and returns it.

defaultVal is returned if the key is not found.

double wxConfigBase::ReadDouble | ( | const wxString & | key,
|  | double | defaultVal
| ) |  | const

Reads a double value from the key and returns it.

defaultVal is returned if the key is not found.

long wxConfigBase::ReadLong | ( | const wxString & | key,
|  | long | defaultVal
| ) |  | const

Reads a long value from the key and returns it.

defaultVal is returned if the key is not found.

T wxConfigBase::ReadObject | ( | const wxString & | key,
|  | T const & | defaultVal
| ) |  | const

Reads a value of type T (for which the function wxFromString() must be defined) from the key and returns it.

defaultVal is returned if the key is not found.

virtual bool wxConfigBase::RenameEntry | ( | const wxString & | oldName,
|  | const wxString & | newName
| ) |  |
| pure virtual

Renames an entry in the current group.

The entries names (both the old and the new one) shouldn't contain backslashes, i.e. only simple names and not arbitrary paths are accepted by this function.

Returns
  false if oldName doesn't exist or if newName already exists.

Implemented in wxFileConfig.

virtual bool wxConfigBase::RenameGroup | ( | const wxString & | oldName,
|  | const wxString & | newName
| ) |  |
| pure virtual

Renames a subgroup of the current group.

The subgroup names (both the old and the new one) shouldn't contain backslashes, i.e. only simple names and not arbitrary paths are accepted by this function.

Returns
  false if oldName doesn't exist or if newName already exists.

Implemented in wxFileConfig.

static wxConfigBase* wxConfigBase::Set | ( | wxConfigBase * | pConfig | ) |
| static

Sets the config object as the current one, returns the pointer to the previous current object (both the parameter and returned value may be NULL).

void wxConfigBase::SetExpandEnvVars | ( | bool | bDoIt = `true` | ) |

Determine whether we wish to expand environment variables in key values.

virtual void wxConfigBase::SetPath | ( | const wxString & | strPath | ) |
| pure virtual

Set current path: if the first character is '/', it is the absolute path, otherwise it is a relative path.

'..' is supported. If strPath doesn't exist, it is created.

See Also
  wxConfigPathChanger

Implemented in wxFileConfig.

void wxConfigBase::SetRecordDefaults | ( | bool | bDoIt = `true` | ) |

Sets whether defaults are recorded to the config file whenever an attempt to read the value which is not present in it is done.

If on (default is off) all default values for the settings used by the program are written back to the config file. This allows the user to see what config options may be changed and is probably useful only for wxFileConfig.

bool wxConfigBase::Write | ( | const wxString & | key,
|  | const wxString & | value
| ) |  |

Writes the wxString value to the config file and returns true on success.

bool wxConfigBase::Write | ( | const wxString & | key,
|  | long | value
| ) |  |

Writes the long value to the config file and returns true on success.

bool wxConfigBase::Write | ( | const wxString & | key,
|  | double | value
| ) |  |

Writes the double value to the config file and returns true on success.

Notice that if floating point numbers are saved as strings (as is the case with the configuration files used by wxFileConfig), this function uses the C locale for writing out the number, i.e. it will always use a period as the decimal separator, irrespectively of the current locale. This behaviour is new since wxWidgets 2.9.1 as the current locale was used before, but the change should be transparent because both C and current locales are tried when reading the numbers back.

bool wxConfigBase::Write | ( | const wxString & | key,
|  | bool | value
| ) |  |

Writes the bool value to the config file and returns true on success.

bool wxConfigBase::Write | ( | const wxString & | key,
|  | const wxMemoryBuffer & | buf
| ) |  |

Writes the wxMemoryBuffer value to the config file and returns true on success.

bool wxConfigBase::Write | ( | const wxString & | key,
|  | T const & | buf
| ) |  |

Writes the specified value to the config file and returns true on success.

The function wxToString() must be defined for type T.